"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@scrabble-solver/types");
const crawlEnglish_1 = __importDefault(require("./crawlEnglish"));
const crawlFarsi_1 = __importDefault(require("./crawlFarsi"));
const crawlFrench_1 = __importDefault(require("./crawlFrench"));
const crawlGerman_1 = __importDefault(require("./crawlGerman"));
const crawlPolish_1 = __importDefault(require("./crawlPolish"));
const crawlRomanian_1 = __importDefault(require("./crawlRomanian"));
const crawlSpanish_1 = __importDefault(require("./crawlSpanish"));
const crawlPerLocale = {
    [types_1.Locale.DE_DE]: crawlGerman_1.default,
    [types_1.Locale.EN_GB]: crawlEnglish_1.default,
    [types_1.Locale.EN_US]: crawlEnglish_1.default,
    [types_1.Locale.ES_ES]: crawlSpanish_1.default,
    [types_1.Locale.FA_IR]: crawlFarsi_1.default,
    [types_1.Locale.FR_FR]: crawlFrench_1.default,
    [types_1.Locale.PL_PL]: crawlPolish_1.default,
    [types_1.Locale.RO_RO]: crawlRomanian_1.default,
};
const crawl = (locale, word) => {
    return crawlPerLocale[locale](word);
};
exports.default = crawl;
