"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@scrabble-solver/types");
const lib_1 = require("../lib");
const parseEnglish_1 = __importDefault(require("./parseEnglish"));
const parseFarsi_1 = __importDefault(require("./parseFarsi"));
const parseFrench_1 = __importDefault(require("./parseFrench"));
const parseGerman_1 = __importDefault(require("./parseGerman"));
const parsePolish_1 = __importDefault(require("./parsePolish"));
const parseRomanian_1 = __importDefault(require("./parseRomanian"));
const parseSpanish_1 = __importDefault(require("./parseSpanish"));
const parsePerLocale = {
    [types_1.Locale.DE_DE]: parseGerman_1.default,
    [types_1.Locale.EN_GB]: parseEnglish_1.default,
    [types_1.Locale.EN_US]: parseEnglish_1.default,
    [types_1.Locale.ES_ES]: parseSpanish_1.default,
    [types_1.Locale.FA_IR]: parseFarsi_1.default,
    [types_1.Locale.FR_FR]: parseFrench_1.default,
    [types_1.Locale.PL_PL]: parsePolish_1.default,
    [types_1.Locale.RO_RO]: parseRomanian_1.default,
};
const parse = (locale, html) => {
    const { definitions, exists } = parsePerLocale[locale](html);
    return {
        definitions: (0, lib_1.unique)(definitions.map(lib_1.normalizeDefinition).filter(Boolean)),
        exists,
    };
};
exports.default = parse;
