"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@scrabble-solver/types");
const getDeDeWordList_1 = __importDefault(require("./getDeDeWordList"));
const getEnGbWordList_1 = __importDefault(require("./getEnGbWordList"));
const getEnUsWordList_1 = __importDefault(require("./getEnUsWordList"));
const getEsEsWordList_1 = __importDefault(require("./getEsEsWordList"));
const getFaIrWordList_1 = __importDefault(require("./getFaIrWordList"));
const getFrFrWordList_1 = __importDefault(require("./getFrFrWordList"));
const getPlPlWordList_1 = __importDefault(require("./getPlPlWordList"));
const getRoRoWordList_1 = __importDefault(require("./getRoRoWordList"));
const localeMap = {
    [types_1.Locale.DE_DE]: getDeDeWordList_1.default,
    [types_1.Locale.EN_GB]: getEnGbWordList_1.default,
    [types_1.Locale.EN_US]: getEnUsWordList_1.default,
    [types_1.Locale.ES_ES]: getEsEsWordList_1.default,
    [types_1.Locale.FA_IR]: getFaIrWordList_1.default,
    [types_1.Locale.FR_FR]: getFrFrWordList_1.default,
    [types_1.Locale.PL_PL]: getPlPlWordList_1.default,
    [types_1.Locale.RO_RO]: getRoRoWordList_1.default,
};
const getWordList = (locale) => localeMap[locale]();
exports.default = getWordList;
